#include <Adafruit_NeoPixel.h>
#include <Wire.h>
#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h>


#define LED 3 
#define voice 13
#define NUM_LEDS 16
#define SCREEN_WIDTH 128 // OLED display width, in pixels
#define SCREEN_HEIGHT 64 // OLED display height, in pixels
#define OLED_RESET -1    // Reset pin # (or -1 if sharing Arduino reset pin)
#define SCREEN_ADDRESS 0x3c
#define I2C_SDA 4
#define I2C_SCL 5
Adafruit_SSD1306 display(SCREEN_WIDTH, SCREEN_HEIGHT, &Wire, OLED_RESET);

Adafruit_NeoPixel strip = Adafruit_NeoPixel(NUM_LEDS, LED, NEO_GRB + NEO_KHZ800);

int count = 0;
int color=0;
int number = 0;





void setup() {

    pinMode(voice, INPUT);  //Set the "voice" pin as an input.
    strip.begin();
    strip.setBrightness(60);
    strip.clear();
    strip.show();
    
    Serial.begin(115200);
    Wire.begin(I2C_SDA, I2C_SCL);
    if (!display.begin(SSD1306_SWITCHCAPVCC, SCREEN_ADDRESS)) {
        Serial.println(F("SSD1306 allocation failed"));
        for (;;); // Don't proceed, loop forever
    }
}

void loop() {

      if(digitalRead(voice) == 0){

       count++;
        if (count>120){
          count = 1;               
        }     
     }     
    light();  
    display.clearDisplay();
    display.setCursor(10, 10);
    display.setTextColor(WHITE);
    display.setTextSize(1);
    display.println("Makerfabs");
    display.setCursor(10, 25);
    display.setTextColor(WHITE);
    display.setTextSize(1);
    display.println("MaESP ESP32 Dev Kit");
    display.setCursor(10, 40);
    display.setTextColor(WHITE);
    display.setTextSize(1);
    display.println("count:" + String(count));
//    display.setCursor(10, 55);
//    display.setTextColor(WHITE);
//    display.setTextSize(1);
//    display.println("color:" + String(color) +"  " + "number:" + String(number));
    display.display();
    strip.show(); 
    delay(200);
    
     

}

    
void light() {


color = (count-1)/12;
number = (count-1)%12;

    switch (color)
    {
    case 0:
        color_show( number, 255, 255, 255);
        break;
    case 1:
        color_show( number, 0, 0, 255);
        break;
    case 2:
        color_show( number, 0, 255, 0);
        break;
    case 3:
        color_show( number, 0, 255, 255);
        break;
    case 4:
        color_show( number, 255, 0, 0);
        break;
    case 5:
        color_show( number, 255, 0, 255);
        break;
    case 6:
        color_show( number, 255, 255, 0);
        break;
    case 7:
        color_show( number, 255, 127, 127);
        break;        
    case 8:
        color_show( number, 127, 255, 127);
        break;
    case 9:
        color_show( number, 127, 127, 255);
        break;

    default:
        color_show( number, 0, 0, 0);
        return;
    }

}

void color_show(int number, int red, int green, int blue){
  for (int i = 0; i <NUM_LEDS - 4; i++){
    if (i <= number){
      strip.setPixelColor(i, red, green, blue);
    }
    else{
      strip.setPixelColor(i, 0, 0, 0);  
    }
  }
}

    
